﻿using System;
using System.Data;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    public static DataTable data;
    public _Default()
    {
        if (data == null)
        {
            data = GetDataSource();
        }
    }
    protected void Page_Load(object sender, EventArgs e)
    {
        grid.DataSource = data;
    }

    public DataTable GetDataSource()
    {
        DataTable dt = new DataTable("Table");
        dt.Columns.Add("id");
        dt.Columns.Add("Text");
        dt.Columns.Add("Checked");
        dt.Columns.Add("Number");

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = dt.Columns["id"];
        dt.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 3; i++)
        {
            bool isChecked = (i % 2 == 0) ? true : false;
            string chked = (i % 2 == 0) ? "Is checked" : "Is not checked";

            dt.Rows.Add(new object[] { i, chked, isChecked, i + 20 });
        }
        return dt;
    }

    protected void grid_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        CheckBox checkBox = e.Row.Items[2].FindControl("CheckBox") as CheckBox;
        checkBox.Checked = bool.Parse(e.Row.Items[1].Value.ToString());
        checkBox.InputAttributes.Add("onchange", "setValue(this)");
    }

    protected void grid_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {
        var isChecked = bool.Parse(e.Values["Checked"].ToString());
        string chked = (isChecked) ? "Is checked" : "Is not checked";
        data.Rows[e.RowID.Index]["Text"] = chked;

        CheckBox checkBox = e.Row.Items[2].FindControl("CheckBox") as CheckBox;
        checkBox.Checked =isChecked;
    }
}